/*
 * dates.c --
 *
 *	Definition for simple date/time converters.
 *
 * Copyright (C) 1998 Andreas Kupries (a.kupries@westend.com)
 * All rights reserved.
 *
 * Permission is hereby granted, without written agreement and without
 * license or royalty fees, to use, copy, modify, and distribute this
 * software and its documentation for any purpose, provided that the
 * above copyright notice and the following two paragraphs appear in
 * all copies of this software.
 *
 * IN NO EVENT SHALL I BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL,
 * INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OF THIS
 * SOFTWARE AND ITS DOCUMENTATION, EVEN IF I HAVE BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * I SPECIFICALLY DISCLAIM ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND
 * I HAVE NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
 * ENHANCEMENTS, OR MODIFICATIONS.
 *
 * CVS: $Id: dates.c,v 1.1 1999/03/27 13:26:31 aku Exp $
 */

#include "pi-config.h" /* Access pilot-link configuration => time header */
#include "dates.h"


Tcl_Obj*
PiTclDateToObj (interp, itemPtr, clientData)
Tcl_Interp* interp;
void*       itemPtr;
ClientData  clientData;
{
  /* date => time_t integer */

  struct tm* date = (struct tm*) itemPtr;
  time_t     t;
  Tcl_Obj*   res;

  /* --
  printf ("year  = %d\n", date->tm_year);
  printf ("month = %d\n", date->tm_mon);
  printf ("day   = %d\n", date->tm_mday);
  printf ("hour  = %d\n", date->tm_hour);
  printf ("min   = %d\n", date->tm_min);
  printf ("isdst = %d\n", date->tm_isdst);
  -- */

  t    = mktime (date);

  /* --  printf ("time_t = %ld\n", t); -- */

  res  = Tcl_NewIntObj (t);

  if (res == (Tcl_Obj*) NULL) {
    return (Tcl_Obj*) NULL;
  }

  return res;
}


int
PiTclDateFromObj (interp, o, itemPtr, clientData)
Tcl_Interp* interp;
Tcl_Obj*    o;
void*       itemPtr;
ClientData  clientData;
{
  /* time_t integer => string */

  int    res;
  time_t t;
  struct tm* date = (struct tm*) itemPtr;
  struct tm* ot;

  res = Tcl_GetLongFromObj (interp, o, &t);

  if (res != TCL_OK) {
    return res;
  }

  ot = localtime (&t);

  memcpy (date, ot, sizeof (struct tm));
  return TCL_OK;
}

